#include <bits/stdc++.h>

using namespace std;

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t,n,k;
    cin>>t>>n>>k;
    vector<int> a(n);
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    sort(a.begin(),a.end());
    int tek=0;
    for(int i=0;i<n;i++){
        tek+=(a[i]>=tek)?1:-1;
    }
    if(k==tek){cout<<"DA";
    for(const auto& vala:a)cout<<vala<<" ";
    }
    else cout<<"NE";
    //
}